---
created_at: '2014-07-11T21:25:10.000Z'
title: Compiling with Continuations, Continued (2007) [pdf]
url: http://research.microsoft.com/en-us/um/people/akenn/sml/CompilingWithContinuationsContinued.pdf
author: chicken_lady
points: 47
story_text: ''
comment_text: 
num_comments: 8
story_id: 
story_title: 
story_url: 
parent_id: 
created_at_i: 1405113910
_tags:
- story
- author_chicken_lady
- story_8022509
objectID: '8022509'

---
[Source](https://www.microsoft.com/en-us/research/people/?from=http%3A%2F%2Fresearch.microsoft.com%2Fen-us%2Fum%2Fpeople%2Fakenn%2Fsml%2Fcompilingwithcontinuationscontinued.pdf "Permalink to People - Microsoft Research")

# People - Microsoft Research

Try Microsoft Edge A fast and secure browser that's designed for Windows 10 No thanks Get started

This site uses cookies for analytics, personalized content and ads. By continuing to browse this site, you agree to this use. [Learn more][1]

[ ![][2] Microsoft ][3]

Research

* [Microsoft 365][4]
* [Azure][5]
* [Office 365][6]
* [Dynamics 365][7]
* [SQL][8]
* [Windows 10][9]
* More
    * Products & Services
        * [Windows Server][10]
        * [Enterprise Mobility + Security][11]
        * [Power BI][12]
        * [Teams][13]
        * [Visual Studio][14]
        * [Surface for Business][15]
    * Emerging Technologies
        * [AI][16]
        * [Internet of Things][17]
        * [Azure Cognitive Services][18]
        * [Quantum][19]
        * [Research][20]
    * Developer & IT
        * [Docs][21]
        * [TechNet][22]
        * [Developer Network][23]
        * [Windows Dev Center][24]
        * [Windows IT Pro Center][25]
        * [FastTrack][26]
    * Partner
        * [Partner Network][27]
        * [Solution Providers][28]
        * [Partner Center][29]
        * [Cloud Hosting][30]
    * Industries
        * [Education][31]
        * [Financial services][32]
        * [Government][33]
        * [Health][34]
        * [Manufacturing & resources][35]
        * [Retail][36]
    * Other
        * [Security][37]
        * [Licensing][38]
        * [AppSource][39]
        * [Azure Marketplace][40]
        * [Events][41]
    * [View all][42]

[ Research ][43] [Research Home][43]

Research areas

* Intelligence
    * [Artificial Intelligence][44]
    * [Computer vision][45]
    * [Graphics & multimedia][46]
    * [Human-computer interaction][47]
    * [Human language technologies][48]
    * [Search & information retrieval][49]
* Systems
    * [Data visualization, analytics & platform][50]
    * [Hardware, devices & quantum computing][51]
    * [Programming languages & software engineering][52]
    * [Security, privacy & cryptography][53]
    * [Systems & networking][54]
* Theory
    * [Algorithms][55]
    * [Mathematics][56]
* Other Sciences
    * [Ecology & environment][57]
    * [Economics][58]
    * [Medical, health & genomics][59]
    * [Social sciences][60]
    * [Technology for emerging markets][61]

[Products & Downloads][62]

Programs & Events

* [Academic Programs][63]
* [Events & Conferences][64]

[People][65] [Careers][66]

Blogs & Podcasts

* [Microsoft Research Blog][67]
* [The Microsoft Research Podcast][68]
* [The AI Blog][69]

Labs & Locations

* Microsoft Research
    * [MSR AI][70]
    * [Asia Lab (Chinese)][71]
    * [Asia Lab (English)][72]
    * [Cambridge Lab][73]
    * [India Lab][74]
    * [Montreal Lab][75]
    * [New England Lab][76]
    * [New York City Lab][77]
    * [Redmond Lab][78]
* Other labs/locations
    * [Applied Sciences Lab][79]
    * [Advanced Technology Lab Cairo][80]
    * [Quantum][81]
* About
    * [Research at Microsoft][82]

![Turning dreams into reality][83]

# Turning dreams into reality

Discover what our researchers around the world have been up to lately.

## People

* [ A-Z ][84]
* [ Leaders ][85]
* [ Emeriti ][86]
* [ Groups ][87]

Search for a person

Filter by last name:

* [All][84]
* [A][88]
* [B][89]
* [C][90]
* [D][91]
* [E][92]
* [F][93]
* [G][94]
* [H][95]
* [I][96]
* [J][97]
* [K][98]
* [L][99]
* [M][100]
* [N][101]
* [O][102]
* [P][103]
* [Q][104]
* [R][105]
* [S][106]
* [T][107]
* [U][108]
* [V][109]
* [W][110]
* [X][111]
* [Y][112]
* [Z][113]

### All A-Z

* [ ![Portrait of Omar Abou El-khir][114] ][115]

####  [Omar Abou El-khir][115]

Research Software Engineer 2

* [ ![Portrait of Tolga Acar][116] ][117]

####  [Tolga Acar][117]

Principal Software Eng Lead

* [ ![Portrait of Mahmoud Adada][118] ][119]

####  [Mahmoud Adada][119]

SR. SDE Manager

* [ ![Portrait of Alekh Agarwal][120] ][121]

####  [Alekh Agarwal][121]

Researcher

* [ ![Portrait of Sharad Agarwal][122] ][123]

####  [Sharad Agarwal][123]

Senior Researcher

* [ ![Portrait of Ronald Aigner][124] ][125]

####  [Ronald Aigner][125]

Principal SDE

* [ ![Portrait of Jacob Alber][126] ][127]

####  [Jacob Alber][127]

Senior Software Engineer

* [ ![Portrait of Miltos Allamanis][128] ][129]

####  [Miltos Allamanis][129]

Researcher

* [ ![Portrait of Zeyuan Allen-Zhu][130] ][131]

####  [Zeyuan Allen-Zhu][131]

Researcher

* [ ![Portrait of Fil Alleva][132] ][133]

####  [Fil Alleva][133]

Partner Research Manager

* [ ![Portrait of Javier Alvarez-Valle][134] ][135]

####  [Javier Alvarez-Valle][135]

Senior Software Engineer

* [ ![Portrait of Saleema Amershi][136] ][137]

####  [Saleema Amershi][137]

Researcher

* [ ![Portrait of Ganesh Ananthanarayanan][138] ][139]

####  [Ganesh Ananthanarayanan][139]

Researcher

* [ ![Portrait of Sean Andrist][140] ][141]

####  [Sean Andrist][141]

Researcher

* [ ![Portrait of Elnaz Ansari][142] ][143]

####  [Elnaz Ansari][143]

Research Circuit Designer 

* [ ![Portrait of Pete Ansell][144] ][145]

####  [Pete Ansell][145]

Senior RSDE

* [ ![Portrait of Andrey Antipov][146] ][147]

####  [Andrey Antipov][147]

Researcher Computational Physics and Condensed Matter Theory

* [ ![Portrait of Arvind Arasu][148] ][149]

####  [Arvind Arasu][149]

Researcher

* [ ![Portrait of Behnaz Arzani][150] ][151]

####  [Behnaz Arzani][151]

Post Doctoral Researcher

* [ ![Portrait of Ahmed Ashour][152] ][153]

####  [Ahmed Ashour][153]

Research Software Development Engineer

* [ ![Portrait of Adam Atkinson][154] ][155]

####  [Adam Atkinson][155]

Software Development Engineer

* [ ![Portrait of Anthony Aue][156] ][157]

####  [Anthony Aue][157]

Principal Software Development Engineer

* [ ![Portrait of Moshe Babaioff][158] ][159]

####  [Moshe Babaioff][159]

Senior Researcher

* [ ![Portrait of Anirudh Badam][160] ][161]

####  [Anirudh Badam][161]

Researcher

Show more researcher profiles

## Microsoft Research Alumni Network

If you were formerly an employee or intern at Microsoft Research, join the newly formed LinkedIn Microsoft Research Alumni Network group. Share, reconnect and network with colleagues who were and are pivotal to driving innovation that empowers every person on the planet.

[LinkedIn Microsoft research alumni network group][162]

## Join us

Change lives and tackle technology's biggest challenges with a team of world-class researchers.

[Check out our open positions and internships][66]

## Awards

Microsoft researchers have received a myriad of prestigious national and international honors, including the ACM A.M. Turing Award, considered the highest distinction in computer science. [Learn more about our award-winning research][163]

##  Follow Microsoft Research 

* * [Follow @MSFTResearch][164]
* ##  Share this page 
* * [Tweet][165]
* #### What's new
* [Surface Book 2][166]
* [Surface Pro][167]
* [Xbox One X][168]
* [Xbox One S][169]
* [VR & mixed reality][170]
* [Windows 10 apps][171]
* [Office apps][172]

#### Store & Support

* [Account profile][173]
* [Download Center][174]
* [Sales & support][175]
* [Returns][176]
* [Order tracking][177]
* [Store locations][178]
* [Support][179]
* [Buy online, pick up in store][180]

#### Education

* [Microsoft in education][31]
* [Office for students][181]
* [Office 365 for schools][182]
* [Deals for students & educators ][183]
* [Microsoft Azure in education][184]

#### Enterprise

* [Microsoft Azure ][185]
* [Enterprise][186]
* [Data platform][187]
* [Find a solutions provider][188]
* [Microsoft partner resources ][189]
* [Microsoft AppSource ][190]
* [Manufacturing & resources][35]
* [Financial services][32]

#### Developer

* [Microsoft Visual Studio][14]
* [Windows Dev Center][24]
* [Developer Network][23]
* [TechNet][191]
* [Microsoft Virtual Academy][192]
* [Microsoft developer program][193]
* [Channel 9][194]
* [Office Dev Center][195]

#### Company

* [Careers][196]
* [About Microsoft][197]
* [Company news][198]
* [Privacy at Microsoft][199]
* [Investors][200]
* [Diversity and inclusion][201]
* [Accessibility][202]
* [Security][203]
* [Sitemap][204]
* [Contact us][205]
* [Privacy & cookies ][206]
* [Terms of use][207]
* [Trademarks][208]
* [About our ads][209]
* © Microsoft 2018

![][210]

[1]: https://go.microsoft.com/fwlink/?linkid=845480
[2]: https://img-prod-cms-rt-microsoft-com.akamaized.net/cms/api/am/imageFileData/RE1Mu3b?ver=5c31
[3]: https://www.microsoft.com
[4]: https://www.microsoft.com/en-us/microsoft-365
[5]: https://azure.microsoft.com
[6]: https://products.office.com/en-us/business/office
[7]: https://dynamics.microsoft.com/en-us/
[8]: https://www.microsoft.com/sql-server/
[9]: https://www.microsoft.com/en-us/windowsforbusiness
[10]: https://www.microsoft.com/cloud-platform/windows-server
[11]: https://www.microsoft.com/cloud-platform/enterprise-mobility-security
[12]: https://powerbi.microsoft.com/en-us/
[13]: https://products.office.com/en-us/microsoft-teams/group-chat-software
[14]: https://www.visualstudio.com/
[15]: https://www.microsoft.com/en-us/surface/business/overview
[16]: https://www.microsoft.com/ai/
[17]: https://www.microsoft.com/internet-of-things
[18]: https://azure.microsoft.com/services/cognitive-services/
[19]: https://www.microsoft.com/quantum/
[20]: https://www.microsoft.com/research/
[21]: https://docs.microsoft.com/en-us/
[22]: https://technet.microsoft.com/en-us/ms376608.aspx
[23]: https://msdn.microsoft.com/en-us
[24]: https://developer.microsoft.com/en-us/windows
[25]: https://www.microsoft.com/en-us/itpro/windows
[26]: https://fasttrack.microsoft.com/office
[27]: https://partner.microsoft.com/
[28]: https://www.microsoft.com/solution-providers/
[29]: https://partnercenter.microsoft.com/partner/home
[30]: https://www.microsoft.com/en-us/cloudandhosting
[31]: https://www.microsoft.com/en-us/education
[32]: https://enterprise.microsoft.com/en-us
[33]: https://enterprise.microsoft.com/en-us/industries/government/
[34]: https://enterprise.microsoft.com/en-us/industries/health/
[35]: https://enterprise.microsoft.com/en-us/industries/discrete-manufacturing/
[36]: https://enterprise.microsoft.com/en-us/industries/retail-and-consumer-goods/
[37]: https://www.microsoft.com/security/
[38]: https://www.microsoft.com/licensing/
[39]: https://appsource.microsoft.com/
[40]: https://azuremarketplace.microsoft.com/marketplace/
[41]: https://events.microsoft.com/
[42]: https://www.microsoft.com/en-us/sitemap.aspx
[43]: https://www.microsoft.com/en-us/research/
[44]: https://www.microsoft.com/en-us/research/research-area/artificial-intelligence/
[45]: https://www.microsoft.com/en-us/research/research-area/computer-vision/
[46]: https://www.microsoft.com/en-us/research/research-area/graphics-and-multimedia/
[47]: https://www.microsoft.com/en-us/research/research-area/human-computer-interaction/
[48]: https://www.microsoft.com/en-us/research/research-area/human-language-technologies/
[49]: https://www.microsoft.com/en-us/research/research-area/search-information-retrieval/
[50]: https://www.microsoft.com/en-us/research/research-area/data-visualization-analytics-platform/
[51]: https://www.microsoft.com/en-us/research/research-area/hardware-devices-quantum-computing/
[52]: https://www.microsoft.com/en-us/research/research-area/programming-languages-software-engineering/
[53]: https://www.microsoft.com/en-us/research/research-area/security-privacy-cryptography/
[54]: https://www.microsoft.com/en-us/research/research-area/systems-and-networking/
[55]: https://www.microsoft.com/en-us/research/research-area/algorithms/
[56]: https://www.microsoft.com/en-us/research/research-area/computational-sciences-mathematics/
[57]: https://www.microsoft.com/en-us/research/research-area/ecology-environment/
[58]: https://www.microsoft.com/en-us/research/research-area/economics/
[59]: https://www.microsoft.com/en-us/research/research-area/medical-health-genomics/
[60]: https://www.microsoft.com/en-us/research/research-area/social-sciences/
[61]: https://www.microsoft.com/en-us/research/research-area/technology-for-emerging-markets/
[62]: https://www.microsoft.com/en-us/research/products/
[63]: https://www.microsoft.com/en-us/research/academic-programs/
[64]: https://www.microsoft.com/en-us/research/events-conferences/
[65]: https://www.microsoft.com/en-us/research/people/
[66]: https://www.microsoft.com/en-us/research/careers/
[67]: https://www.microsoft.com/en-us/research/blog
[68]: https://www.microsoft.com/en-us/research/blog/category/podcast/
[69]: https://blogs.microsoft.com/next/
[70]: https://www.microsoft.com/en-us/research/lab/microsoft-research-ai/
[71]: http://www.msra.cn
[72]: https://www.microsoft.com/en-us/research/lab/microsoft-research-asia/
[73]: https://www.microsoft.com/en-us/research/lab/microsoft-research-cambridge/
[74]: https://www.microsoft.com/en-us/research/lab/microsoft-research-india/
[75]: https://www.microsoft.com/en-us/research/lab/microsoft-research-montreal/
[76]: https://www.microsoft.com/en-us/research/lab/microsoft-research-new-england/
[77]: https://www.microsoft.com/en-us/research/lab/microsoft-research-new-york/
[78]: https://www.microsoft.com/en-us/research/lab/microsoft-research-redmond/
[79]: https://www.microsoft.com/en-us/research/lab/applied-sciences-group/
[80]: https://www.microsoft.com/en-us/research/group/advanced-technology-lab-cairo-2/
[81]: https://www.microsoft.com/en-us/research/lab/quantum/
[82]: https://www.microsoft.com/en-us/research/about/
[83]: https://www.microsoft.com/en-us/research/wp-content/uploads/2015/12/Banner_Options_29-800x550.jpg
[84]: https://www.microsoft.com/en-us/research/people
[85]: https://www.microsoft.com/en-us/research/people?filter_type=leadership
[86]: https://www.microsoft.com/en-us/research/people?filter_type=emeriti
[87]: https://www.microsoft.com/en-us/research/people?filter_type=groups
[88]: https://www.microsoft.com/en-us/research/people?filter=a
[89]: https://www.microsoft.com/en-us/research/people?filter=b
[90]: https://www.microsoft.com/en-us/research/people?filter=c
[91]: https://www.microsoft.com/en-us/research/people?filter=d
[92]: https://www.microsoft.com/en-us/research/people?filter=e
[93]: https://www.microsoft.com/en-us/research/people?filter=f
[94]: https://www.microsoft.com/en-us/research/people?filter=g
[95]: https://www.microsoft.com/en-us/research/people?filter=h
[96]: https://www.microsoft.com/en-us/research/people?filter=i
[97]: https://www.microsoft.com/en-us/research/people?filter=j
[98]: https://www.microsoft.com/en-us/research/people?filter=k
[99]: https://www.microsoft.com/en-us/research/people?filter=l
[100]: https://www.microsoft.com/en-us/research/people?filter=m
[101]: https://www.microsoft.com/en-us/research/people?filter=n
[102]: https://www.microsoft.com/en-us/research/people?filter=o
[103]: https://www.microsoft.com/en-us/research/people?filter=p
[104]: https://www.microsoft.com/en-us/research/people?filter=q
[105]: https://www.microsoft.com/en-us/research/people?filter=r
[106]: https://www.microsoft.com/en-us/research/people?filter=s
[107]: https://www.microsoft.com/en-us/research/people?filter=t
[108]: https://www.microsoft.com/en-us/research/people?filter=u
[109]: https://www.microsoft.com/en-us/research/people?filter=v
[110]: https://www.microsoft.com/en-us/research/people?filter=w
[111]: https://www.microsoft.com/en-us/research/people?filter=x
[112]: https://www.microsoft.com/en-us/research/people?filter=y
[113]: https://www.microsoft.com/en-us/research/people?filter=z
[114]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/06/avatar_user__1467331484-180x180.jpg
[115]: https://www.microsoft.com/en-us/research/people/omara/
[116]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/WP_20140325_13_32_06_Pro-180x180.jpg
[117]: https://www.microsoft.com/en-us/research/people/tolga/
[118]: https://www.microsoft.com/en-us/research/wp-content/uploads/2017/11/avatar_user_37176_1511986368-180x180.jpg
[119]: https://www.microsoft.com/en-us/research/people/maadada/
[120]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/09/avatar_user__1474904133-180x180.jpg
[121]: https://www.microsoft.com/en-us/research/people/alekha/
[122]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/07/avatar_user__1467844017-180x180.jpg
[123]: https://www.microsoft.com/en-us/research/people/sagarwal/
[124]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/05/avatar_user__1462296125-180x180.jpg
[125]: https://www.microsoft.com/en-us/research/people/raigner/
[126]: https://www.microsoft.com/en-us/research/wp-content/uploads/2017/08/avatar_user_36747_1503938299-180x180.jpg
[127]: https://www.microsoft.com/en-us/research/people/jaalber/
[128]: https://www.microsoft.com/en-us/research/uploads/prod/2018/01/Miltos-Allamanis.jpg
[129]: https://www.microsoft.com/en-us/research/people/miallama/
[130]: https://www.microsoft.com/en-us/research/wp-content/uploads/2017/10/avatar_user_36569_1507086345-180x180.jpg
[131]: https://www.microsoft.com/en-us/research/people/zeyuana/
[132]: https://www.microsoft.com/en-us/research/wp-content/uploads/2017/07/avatar_user_31811_1499708025.jpg
[133]: https://www.microsoft.com/en-us/research/people/fil/
[134]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/06/foto-1-180x180.jpg
[135]: https://www.microsoft.com/en-us/research/people/jaalvare/
[136]: https://www.microsoft.com/en-us/research/wp-content/uploads/2017/10/avatar_user_33505_1508798589-180x180.jpg
[137]: https://www.microsoft.com/en-us/research/people/samershi/
[138]: https://www.microsoft.com/en-us/research/wp-content/uploads/2017/03/avatar_user__1488992664-180x180.png
[139]: https://www.microsoft.com/en-us/research/people/ga/
[140]: https://www.microsoft.com/en-us/research/wp-content/uploads/2017/09/avatar_user_36443_1506533427-180x180.jpg
[141]: https://www.microsoft.com/en-us/research/people/sandrist/
[142]: https://www.microsoft.com/en-us/research/wp-content/uploads/2017/09/avatar_user_36891_1506445059-180x180.jpg
[143]: https://www.microsoft.com/en-us/research/people/elansari/
[144]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/06/avatar_user__1467155171-180x180.png
[145]: https://www.microsoft.com/en-us/research/people/petea/
[146]: https://www.microsoft.com/en-us/research/wp-content/uploads/2017/09/avatar_user_36810_1505776738-180x180.jpg
[147]: https://www.microsoft.com/en-us/research/people/anantipo/
[148]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/02/Headshot__0145_cropped_arvind-arasu-180x180.jpg
[149]: https://www.microsoft.com/en-us/research/people/arvinda/
[150]: https://www.microsoft.com/en-us/research/uploads/prod/2018/02/profile-5a871cd82b8cd.jpg
[151]: https://www.microsoft.com/en-us/research/people/bearzani/
[152]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/01/ahmed-ashour-2.jpg
[153]: https://www.microsoft.com/en-us/research/people/aash/
[154]: https://www.microsoft.com/en-us/research/wp-content/uploads/2017/11/avatar_user_37095_1510682699-180x180.jpg
[155]: https://www.microsoft.com/en-us/research/people/adatkins/
[156]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/12/avatar_user__1481825117-180x180.jpg
[157]: https://www.microsoft.com/en-us/research/people/anthaue/
[158]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/01/moshe-babaioff-1.jpg
[159]: https://www.microsoft.com/en-us/research/people/moshe/
[160]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/11/avatar_user__1478719953.jpg
[161]: https://www.microsoft.com/en-us/research/people/anbadam/
[162]: https://www.linkedin.com/groups/7060091/profile
[163]: https://www.microsoft.com/en-us/research/awards/
[164]: https://twitter.com/MSFTResearch
[165]: https://twitter.com/share
[166]: https://www.microsoft.com/en-us/surface/devices/surface-book-2/overview
[167]: https://www.microsoft.com/en-us/surface/devices/surface-pro/overview
[168]: https://www.xbox.com/en-us/xbox-one-x
[169]: https://www.xbox.com/en-us/xbox-one-s?xr=shellnav
[170]: https://www.microsoft.com/en-us/store/b/virtualreality
[171]: https://www.microsoft.com/en-us/windows/windows-10-apps
[172]: https://store.office.com/en-us/appshome.aspx?
[173]: https://account.microsoft.com/
[174]: https://www.microsoft.com/en-us/download
[175]: https://go.microsoft.com/fwlink/p/?LinkID=824761&clcid=0x409
[176]: https://go.microsoft.com/fwlink/p/?LinkID=824764&clcid=0x409
[177]: https://account.microsoft.com/orders
[178]: https://www.microsoft.com/en-us/store/locations/find-a-store
[179]: https://support.microsoft.com/en-us
[180]: https://www.microsoft.com/en-us/store/b/buy-online-pick-up-in-store?icid=uhf_footer_bopuis
[181]: https://www.microsoft.com/en-us/education/products/office/default.aspx
[182]: https://products.office.com/en-us/academic/compare-office-365-education-plans
[183]: https://www.microsoft.com/en-us/store/b/student
[184]: https://azure.microsoft.com/en-us/community/education/
[185]: https://azure.microsoft.com/
[186]: https://enterprise.microsoft.com/en-us/
[187]: https://www.microsoft.com/en-us/sql-server/
[188]: https://www.microsoft.com/en-us/solution-providers
[189]: https://partner.microsoft.com/en-us/
[190]: https://go.microsoft.com/fwlink/?LinkID=808093
[191]: https://technet.microsoft.com/en-us
[192]: https://mva.microsoft.com/
[193]: https://developer.microsoft.com/en-us/store/register
[194]: https://channel9.msdn.com/
[195]: https://developer.microsoft.com/office
[196]: https://careers.microsoft.com/
[197]: https://www.microsoft.com/en-us/about
[198]: https://news.microsoft.com/
[199]: https://privacy.microsoft.com/en-us
[200]: https://www.microsoft.com/investor/default.aspx
[201]: https://www.microsoft.com/en-us/diversity/
[202]: https://www.microsoft.com/en-us/accessibility/home
[203]: https://www.microsoft.com/en-us/security/default.aspx
[204]: https://www.microsoft.com/en-us/sitemap1.aspx
[205]: https://support.microsoft.com/en-us/contactus
[206]: https://go.microsoft.com/fwlink/?LinkId=521839
[207]: https://go.microsoft.com/fwlink/?LinkID=206977
[208]: https://www.microsoft.com/trademarks
[209]: https://choice.microsoft.com
[210]: https://www.facebook.com/tr?id=435868603227390&ev=PageView&noscript=1

