---
created_at: '2015-12-12T20:39:24.000Z'
title: 'Leslie Lamport: Computer Science and State Machines (2008) [pdf]'
url: http://research.microsoft.com/en-us/um/people/lamport/pubs/deroever-festschrift.pdf
author: pron
points: 46
story_text: 
comment_text: 
num_comments: 14
story_id: 
story_title: 
story_url: 
parent_id: 
created_at_i: 1449952764
_tags:
- story
- author_pron
- story_10724041
objectID: '10724041'

---
[Source](https://www.microsoft.com/en-us/research/publication/computer-science-state-machines/?from=http%3A%2F%2Fresearch.microsoft.com%2Fen-us%2Fum%2Fpeople%2Flamport%2Fpubs%2Fderoever-festschrift.pdf "Permalink to Computer Science and State Machines - Microsoft Research")

# Computer Science and State Machines - Microsoft Research

Try Microsoft Edge A fast and secure browser that's designed for Windows 10 No thanks Get started

This site uses cookies for analytics, personalized content and ads. By continuing to browse this site, you agree to this use. [Learn more][1]

[ ![][2] Microsoft ][3]

Research

* [Microsoft 365][4]
* [Azure][5]
* [Office 365][6]
* [Dynamics 365][7]
* [SQL][8]
* [Windows 10][9]
* More
    * Products & Services
        * [Windows Server][10]
        * [Enterprise Mobility + Security][11]
        * [Power BI][12]
        * [Teams][13]
        * [Visual Studio][14]
        * [Surface for Business][15]
    * Emerging Technologies
        * [AI][16]
        * [Internet of Things][17]
        * [Azure Cognitive Services][18]
        * [Quantum][19]
        * [Research][20]
    * Developer & IT
        * [Docs][21]
        * [TechNet][22]
        * [Developer Network][23]
        * [Windows Dev Center][24]
        * [Windows IT Pro Center][25]
        * [FastTrack][26]
    * Partner
        * [Partner Network][27]
        * [Solution Providers][28]
        * [Partner Center][29]
        * [Cloud Hosting][30]
    * Industries
        * [Education][31]
        * [Financial services][32]
        * [Government][33]
        * [Health][34]
        * [Manufacturing & resources][35]
        * [Retail][36]
    * Other
        * [Security][37]
        * [Licensing][38]
        * [AppSource][39]
        * [Azure Marketplace][40]
        * [Events][41]
    * [View all][42]

[ Research ][43] [Research Home][43]

Research areas

* Intelligence
    * [Artificial Intelligence][44]
    * [Computer vision][45]
    * [Graphics & multimedia][46]
    * [Human-computer interaction][47]
    * [Human language technologies][48]
    * [Search & information retrieval][49]
* Systems
    * [Data visualization, analytics & platform][50]
    * [Hardware, devices & quantum computing][51]
    * [Programming languages & software engineering][52]
    * [Security, privacy & cryptography][53]
    * [Systems & networking][54]
* Theory
    * [Algorithms][55]
    * [Mathematics][56]
* Other Sciences
    * [Ecology & environment][57]
    * [Economics][58]
    * [Medical, health & genomics][59]
    * [Social sciences][60]
    * [Technology for emerging markets][61]

[Products & Downloads][62]

Programs & Events

* [Academic Programs][63]
* [Events & Conferences][64]

[People][65] [Careers][66]

Blogs & Podcasts

* [Microsoft Research Blog][67]
* [The Microsoft Research Podcast][68]
* [The AI Blog][69]

Labs & Locations

* Microsoft Research
    * [MSR AI][70]
    * [Asia Lab (Chinese)][71]
    * [Asia Lab (English)][72]
    * [Cambridge Lab][73]
    * [India Lab][74]
    * [Montreal Lab][75]
    * [New England Lab][76]
    * [New York City Lab][77]
    * [Redmond Lab][78]
* Other labs/locations
    * [Applied Sciences Lab][79]
    * [Advanced Technology Lab Cairo][80]
    * [Quantum][81]
* About
    * [Research at Microsoft][82]

#  Computer Science and State Machines 

June 8, 2010 

* [ Download PDF ][83]
* [ BibTex ][84]

##  Authors 

* [Leslie Lamport][85]

## Published In

Concurrency, Compositionality, and Correctness (Essays in Honor of Willem-Paul de Roever). Dennis Dams, Ulrich Hannemann, and Martin Steffen editors. Lecture Notes in Computer Science, number 5930 (2010), 60-65. 

## Publication Type

Article 

## Pages

60-65 

* [ Abstract ][86]
* [ Related Info ][87]

## Abstract

This is the six-page version of [[165]][88]. I think it is also the first place I have mentioned the Whorfian syndrome in print. It is structured around a lovely simple example in which an important hardware protocol is derived from a trivial specification by substituting an expression for the specification’s variable. This example is supporting evidence for the thesis of [[168]][89] that computation should be described with mathematics. (Substitution of an expression for a variable is an elementary operation of mathematics, but is meaningless in a programming language.)

## Related Info

##  Research Areas 

* [ Algorithms ][55]

##  Follow Microsoft Research 

* * [Follow @MSFTResearch][90]
* ##  Share this page 
* * [Tweet][91]
* #### What's new
* [Surface Book 2][92]
* [Surface Pro][93]
* [Xbox One X][94]
* [Xbox One S][95]
* [VR & mixed reality][96]
* [Windows 10 apps][97]
* [Office apps][98]

#### Store & Support

* [Account profile][99]
* [Download Center][100]
* [Sales & support][101]
* [Returns][102]
* [Order tracking][103]
* [Store locations][104]
* [Support][105]
* [Buy online, pick up in store][106]

#### Education

* [Microsoft in education][31]
* [Office for students][107]
* [Office 365 for schools][108]
* [Deals for students & educators ][109]
* [Microsoft Azure in education][110]

#### Enterprise

* [Microsoft Azure ][111]
* [Enterprise][112]
* [Data platform][113]
* [Find a solutions provider][114]
* [Microsoft partner resources ][115]
* [Microsoft AppSource ][116]
* [Manufacturing & resources][35]
* [Financial services][32]

#### Developer

* [Microsoft Visual Studio][14]
* [Windows Dev Center][24]
* [Developer Network][23]
* [TechNet][117]
* [Microsoft Virtual Academy][118]
* [Microsoft developer program][119]
* [Channel 9][120]
* [Office Dev Center][121]

#### Company

* [Careers][122]
* [About Microsoft][123]
* [Company news][124]
* [Privacy at Microsoft][125]
* [Investors][126]
* [Diversity and inclusion][127]
* [Accessibility][128]
* [Security][129]
* [Sitemap][130]
* [Contact us][131]
* [Privacy & cookies ][132]
* [Terms of use][133]
* [Trademarks][134]
* [About our ads][135]
* © Microsoft 2018

![][136]

[1]: https://go.microsoft.com/fwlink/?linkid=845480
[2]: https://img-prod-cms-rt-microsoft-com.akamaized.net/cms/api/am/imageFileData/RE1Mu3b?ver=5c31
[3]: https://www.microsoft.com
[4]: https://www.microsoft.com/en-us/microsoft-365
[5]: https://azure.microsoft.com
[6]: https://products.office.com/en-us/business/office
[7]: https://dynamics.microsoft.com/en-us/
[8]: https://www.microsoft.com/sql-server/
[9]: https://www.microsoft.com/en-us/windowsforbusiness
[10]: https://www.microsoft.com/cloud-platform/windows-server
[11]: https://www.microsoft.com/cloud-platform/enterprise-mobility-security
[12]: https://powerbi.microsoft.com/en-us/
[13]: https://products.office.com/en-us/microsoft-teams/group-chat-software
[14]: https://www.visualstudio.com/
[15]: https://www.microsoft.com/en-us/surface/business/overview
[16]: https://www.microsoft.com/ai/
[17]: https://www.microsoft.com/internet-of-things
[18]: https://azure.microsoft.com/services/cognitive-services/
[19]: https://www.microsoft.com/quantum/
[20]: https://www.microsoft.com/research/
[21]: https://docs.microsoft.com/en-us/
[22]: https://technet.microsoft.com/en-us/ms376608.aspx
[23]: https://msdn.microsoft.com/en-us
[24]: https://developer.microsoft.com/en-us/windows
[25]: https://www.microsoft.com/en-us/itpro/windows
[26]: https://fasttrack.microsoft.com/office
[27]: https://partner.microsoft.com/
[28]: https://www.microsoft.com/solution-providers/
[29]: https://partnercenter.microsoft.com/partner/home
[30]: https://www.microsoft.com/en-us/cloudandhosting
[31]: https://www.microsoft.com/en-us/education
[32]: https://enterprise.microsoft.com/en-us
[33]: https://enterprise.microsoft.com/en-us/industries/government/
[34]: https://enterprise.microsoft.com/en-us/industries/health/
[35]: https://enterprise.microsoft.com/en-us/industries/discrete-manufacturing/
[36]: https://enterprise.microsoft.com/en-us/industries/retail-and-consumer-goods/
[37]: https://www.microsoft.com/security/
[38]: https://www.microsoft.com/licensing/
[39]: https://appsource.microsoft.com/
[40]: https://azuremarketplace.microsoft.com/marketplace/
[41]: https://events.microsoft.com/
[42]: https://www.microsoft.com/en-us/sitemap.aspx
[43]: https://www.microsoft.com/en-us/research/
[44]: https://www.microsoft.com/en-us/research/research-area/artificial-intelligence/
[45]: https://www.microsoft.com/en-us/research/research-area/computer-vision/
[46]: https://www.microsoft.com/en-us/research/research-area/graphics-and-multimedia/
[47]: https://www.microsoft.com/en-us/research/research-area/human-computer-interaction/
[48]: https://www.microsoft.com/en-us/research/research-area/human-language-technologies/
[49]: https://www.microsoft.com/en-us/research/research-area/search-information-retrieval/
[50]: https://www.microsoft.com/en-us/research/research-area/data-visualization-analytics-platform/
[51]: https://www.microsoft.com/en-us/research/research-area/hardware-devices-quantum-computing/
[52]: https://www.microsoft.com/en-us/research/research-area/programming-languages-software-engineering/
[53]: https://www.microsoft.com/en-us/research/research-area/security-privacy-cryptography/
[54]: https://www.microsoft.com/en-us/research/research-area/systems-and-networking/
[55]: https://www.microsoft.com/en-us/research/research-area/algorithms/
[56]: https://www.microsoft.com/en-us/research/research-area/computational-sciences-mathematics/
[57]: https://www.microsoft.com/en-us/research/research-area/ecology-environment/
[58]: https://www.microsoft.com/en-us/research/research-area/economics/
[59]: https://www.microsoft.com/en-us/research/research-area/medical-health-genomics/
[60]: https://www.microsoft.com/en-us/research/research-area/social-sciences/
[61]: https://www.microsoft.com/en-us/research/research-area/technology-for-emerging-markets/
[62]: https://www.microsoft.com/en-us/research/products/
[63]: https://www.microsoft.com/en-us/research/academic-programs/
[64]: https://www.microsoft.com/en-us/research/events-conferences/
[65]: https://www.microsoft.com/en-us/research/people/
[66]: https://www.microsoft.com/en-us/research/careers/
[67]: https://www.microsoft.com/en-us/research/blog
[68]: https://www.microsoft.com/en-us/research/blog/category/podcast/
[69]: https://blogs.microsoft.com/next/
[70]: https://www.microsoft.com/en-us/research/lab/microsoft-research-ai/
[71]: http://www.msra.cn
[72]: https://www.microsoft.com/en-us/research/lab/microsoft-research-asia/
[73]: https://www.microsoft.com/en-us/research/lab/microsoft-research-cambridge/
[74]: https://www.microsoft.com/en-us/research/lab/microsoft-research-india/
[75]: https://www.microsoft.com/en-us/research/lab/microsoft-research-montreal/
[76]: https://www.microsoft.com/en-us/research/lab/microsoft-research-new-england/
[77]: https://www.microsoft.com/en-us/research/lab/microsoft-research-new-york/
[78]: https://www.microsoft.com/en-us/research/lab/microsoft-research-redmond/
[79]: https://www.microsoft.com/en-us/research/lab/applied-sciences-group/
[80]: https://www.microsoft.com/en-us/research/group/advanced-technology-lab-cairo-2/
[81]: https://www.microsoft.com/en-us/research/lab/quantum/
[82]: https://www.microsoft.com/en-us/research/about/
[83]: https://www.microsoft.com/en-us/research/uploads/prod/2016/12/Computer-Science-and-State-Machines.pdf
[84]: https://www.microsoft.com/en-us/research/publication/computer-science-state-machines/bibtex/
[85]: https://www.microsoft.com/en-us/research/people/lamport/
[86]: https://www.microsoft.com#%21abstract
[87]: https://www.microsoft.com#%21related_info
[88]: https://www.microsoft.com/en-us/research/publication/computation-state-machines/
[89]: https://www.microsoft.com/en-us/research/publication/teaching-concurrency/
[90]: https://twitter.com/MSFTResearch
[91]: https://twitter.com/share
[92]: https://www.microsoft.com/en-us/surface/devices/surface-book-2/overview
[93]: https://www.microsoft.com/en-us/surface/devices/surface-pro/overview
[94]: https://www.xbox.com/en-us/xbox-one-x
[95]: https://www.xbox.com/en-us/xbox-one-s?xr=shellnav
[96]: https://www.microsoft.com/en-us/store/b/virtualreality
[97]: https://www.microsoft.com/en-us/windows/windows-10-apps
[98]: https://store.office.com/en-us/appshome.aspx?
[99]: https://account.microsoft.com/
[100]: https://www.microsoft.com/en-us/download
[101]: https://go.microsoft.com/fwlink/p/?LinkID=824761&clcid=0x409
[102]: https://go.microsoft.com/fwlink/p/?LinkID=824764&clcid=0x409
[103]: https://account.microsoft.com/orders
[104]: https://www.microsoft.com/en-us/store/locations/find-a-store
[105]: https://support.microsoft.com/en-us
[106]: https://www.microsoft.com/en-us/store/b/buy-online-pick-up-in-store?icid=uhf_footer_bopuis
[107]: https://www.microsoft.com/en-us/education/products/office/default.aspx
[108]: https://products.office.com/en-us/academic/compare-office-365-education-plans
[109]: https://www.microsoft.com/en-us/store/b/student
[110]: https://azure.microsoft.com/en-us/community/education/
[111]: https://azure.microsoft.com/
[112]: https://enterprise.microsoft.com/en-us/
[113]: https://www.microsoft.com/en-us/sql-server/
[114]: https://www.microsoft.com/en-us/solution-providers
[115]: https://partner.microsoft.com/en-us/
[116]: https://go.microsoft.com/fwlink/?LinkID=808093
[117]: https://technet.microsoft.com/en-us
[118]: https://mva.microsoft.com/
[119]: https://developer.microsoft.com/en-us/store/register
[120]: https://channel9.msdn.com/
[121]: https://developer.microsoft.com/office
[122]: https://careers.microsoft.com/
[123]: https://www.microsoft.com/en-us/about
[124]: https://news.microsoft.com/
[125]: https://privacy.microsoft.com/en-us
[126]: https://www.microsoft.com/investor/default.aspx
[127]: https://www.microsoft.com/en-us/diversity/
[128]: https://www.microsoft.com/en-us/accessibility/home
[129]: https://www.microsoft.com/en-us/security/default.aspx
[130]: https://www.microsoft.com/en-us/sitemap1.aspx
[131]: https://support.microsoft.com/en-us/contactus
[132]: https://go.microsoft.com/fwlink/?LinkId=521839
[133]: https://go.microsoft.com/fwlink/?LinkID=206977
[134]: https://www.microsoft.com/trademarks
[135]: https://choice.microsoft.com
[136]: https://www.facebook.com/tr?id=435868603227390&ev=PageView&noscript=1

