---
created_at: '2015-02-07T20:37:25.000Z'
title: Compiler Construction Using Flex and Bison (2004) [pdf]
url: http://research.microsoft.com/en-us/um/people/rgal/ar_language/external/compiler.pdf
author: GmeSalazar
points: 59
story_text: ''
comment_text: 
num_comments: 0
story_id: 
story_title: 
story_url: 
parent_id: 
created_at_i: 1423341445
_tags:
- story
- author_GmeSalazar
- story_9015228
objectID: '9015228'

---
[Source](https://www.microsoft.com/en-us/research/people/rgal/?from=http%3A%2F%2Fresearch.microsoft.com%2Fen-us%2Fum%2Fpeople%2Frgal%2Far_language%2Fexternal%2Fcompiler.pdf "Permalink to Ran Gal at Microsoft Research")

# Ran Gal at Microsoft Research

Try Microsoft Edge A fast and secure browser that's designed for Windows 10 No thanks Get started

This site uses cookies for analytics, personalized content and ads. By continuing to browse this site, you agree to this use. [Learn more][1]

[ ![][2] Microsoft ][3]

Research

* [Microsoft 365][4]
* [Azure][5]
* [Office 365][6]
* [Dynamics 365][7]
* [SQL][8]
* [Windows 10][9]
* More
    * Products & Services
        * [Windows Server][10]
        * [Enterprise Mobility + Security][11]
        * [Power BI][12]
        * [Teams][13]
        * [Visual Studio][14]
        * [Surface for Business][15]
    * Emerging Technologies
        * [AI][16]
        * [Internet of Things][17]
        * [Azure Cognitive Services][18]
        * [Quantum][19]
        * [Research][20]
    * Developer & IT
        * [Docs][21]
        * [TechNet][22]
        * [Developer Network][23]
        * [Windows Dev Center][24]
        * [Windows IT Pro Center][25]
        * [FastTrack][26]
    * Partner
        * [Partner Network][27]
        * [Solution Providers][28]
        * [Partner Center][29]
        * [Cloud Hosting][30]
    * Industries
        * [Education][31]
        * [Financial services][32]
        * [Government][33]
        * [Health][34]
        * [Manufacturing & resources][35]
        * [Retail][36]
    * Other
        * [Security][37]
        * [Licensing][38]
        * [AppSource][39]
        * [Azure Marketplace][40]
        * [Events][41]
    * [View all][42]

[ Research ][43] [Research Home][43]

Research areas

* Intelligence
    * [Artificial Intelligence][44]
    * [Computer vision][45]
    * [Graphics & multimedia][46]
    * [Human-computer interaction][47]
    * [Human language technologies][48]
    * [Search & information retrieval][49]
* Systems
    * [Data visualization, analytics & platform][50]
    * [Hardware, devices & quantum computing][51]
    * [Programming languages & software engineering][52]
    * [Security, privacy & cryptography][53]
    * [Systems & networking][54]
* Theory
    * [Algorithms][55]
    * [Mathematics][56]
* Other Sciences
    * [Ecology & environment][57]
    * [Economics][58]
    * [Medical, health & genomics][59]
    * [Social sciences][60]
    * [Technology for emerging markets][61]

[Products & Downloads][62]

Programs & Events

* [Academic Programs][63]
* [Events & Conferences][64]

[People][65] [Careers][66]

Blogs & Podcasts

* [Microsoft Research Blog][67]
* [The Microsoft Research Podcast][68]
* [The AI Blog][69]

Labs & Locations

* Microsoft Research
    * [MSR AI][70]
    * [Asia Lab (Chinese)][71]
    * [Asia Lab (English)][72]
    * [Cambridge Lab][73]
    * [India Lab][74]
    * [Montreal Lab][75]
    * [New England Lab][76]
    * [New York City Lab][77]
    * [Redmond Lab][78]
* Other labs/locations
    * [Applied Sciences Lab][79]
    * [Advanced Technology Lab Cairo][80]
    * [Quantum][81]
* About
    * [Research at Microsoft][82]

![Portrait of Ran Gal][83]

# Ran Gal

Researcher

## Contact Info

###  [ Email ][84]

## Research areas

* [Artificial intelligence][44]
* [Computer vision][45]
* [Graphics and multimedia][46]

## Groups

* [Interactive Media Group][85]
* [About][86]
* [Publications][87]
* [Videos][88]
* [CV][89]

## About

I'm researcher at Microsoft Research (MSR), in the eXtreme Computing Group (XCG). My current research focus on Augmented Reality and other computer graphics/vision problems.

I received my PhD from the Tel Aviv University in Israel, and joined Microsoft in 2010.

Prior to joining XCG, I worked as a researcher at Bing Mobile and mapping, developing a system that allows a user to add in-doors mapping information to Bing Maps. By geo-register sketches/floor-plans or any other non-exact visual media to a global map, the user was able to semi-automatically trace and annotate additional information to map, such as interior structure information, public facilities information and more.

## Publications

![][90]

## Videos

![][90]

## Other

[CV][91]

##  Follow Microsoft Research 

* * [Follow @MSFTResearch][92]
* ##  Share this page 
* * [Tweet][93]
* #### What's new
* [Surface Book 2][94]
* [Surface Pro][95]
* [Xbox One X][96]
* [Xbox One S][97]
* [VR & mixed reality][98]
* [Windows 10 apps][99]
* [Office apps][100]

#### Store & Support

* [Account profile][101]
* [Download Center][102]
* [Sales & support][103]
* [Returns][104]
* [Order tracking][105]
* [Store locations][106]
* [Support][107]
* [Buy online, pick up in store][108]

#### Education

* [Microsoft in education][31]
* [Office for students][109]
* [Office 365 for schools][110]
* [Deals for students & educators ][111]
* [Microsoft Azure in education][112]

#### Enterprise

* [Microsoft Azure ][113]
* [Enterprise][114]
* [Data platform][115]
* [Find a solutions provider][116]
* [Microsoft partner resources ][117]
* [Microsoft AppSource ][118]
* [Manufacturing & resources][35]
* [Financial services][32]

#### Developer

* [Microsoft Visual Studio][14]
* [Windows Dev Center][24]
* [Developer Network][23]
* [TechNet][119]
* [Microsoft Virtual Academy][120]
* [Microsoft developer program][121]
* [Channel 9][122]
* [Office Dev Center][123]

#### Company

* [Careers][124]
* [About Microsoft][125]
* [Company news][126]
* [Privacy at Microsoft][127]
* [Investors][128]
* [Diversity and inclusion][129]
* [Accessibility][130]
* [Security][131]
* [Sitemap][132]
* [Contact us][133]
* [Privacy & cookies ][134]
* [Terms of use][135]
* [Trademarks][136]
* [About our ads][137]
* © Microsoft 2018

![][138]

[1]: https://go.microsoft.com/fwlink/?linkid=845480
[2]: https://img-prod-cms-rt-microsoft-com.akamaized.net/cms/api/am/imageFileData/RE1Mu3b?ver=5c31
[3]: https://www.microsoft.com
[4]: https://www.microsoft.com/en-us/microsoft-365
[5]: https://azure.microsoft.com
[6]: https://products.office.com/en-us/business/office
[7]: https://dynamics.microsoft.com/en-us/
[8]: https://www.microsoft.com/sql-server/
[9]: https://www.microsoft.com/en-us/windowsforbusiness
[10]: https://www.microsoft.com/cloud-platform/windows-server
[11]: https://www.microsoft.com/cloud-platform/enterprise-mobility-security
[12]: https://powerbi.microsoft.com/en-us/
[13]: https://products.office.com/en-us/microsoft-teams/group-chat-software
[14]: https://www.visualstudio.com/
[15]: https://www.microsoft.com/en-us/surface/business/overview
[16]: https://www.microsoft.com/ai/
[17]: https://www.microsoft.com/internet-of-things
[18]: https://azure.microsoft.com/services/cognitive-services/
[19]: https://www.microsoft.com/quantum/
[20]: https://www.microsoft.com/research/
[21]: https://docs.microsoft.com/en-us/
[22]: https://technet.microsoft.com/en-us/ms376608.aspx
[23]: https://msdn.microsoft.com/en-us
[24]: https://developer.microsoft.com/en-us/windows
[25]: https://www.microsoft.com/en-us/itpro/windows
[26]: https://fasttrack.microsoft.com/office
[27]: https://partner.microsoft.com/
[28]: https://www.microsoft.com/solution-providers/
[29]: https://partnercenter.microsoft.com/partner/home
[30]: https://www.microsoft.com/en-us/cloudandhosting
[31]: https://www.microsoft.com/en-us/education
[32]: https://enterprise.microsoft.com/en-us
[33]: https://enterprise.microsoft.com/en-us/industries/government/
[34]: https://enterprise.microsoft.com/en-us/industries/health/
[35]: https://enterprise.microsoft.com/en-us/industries/discrete-manufacturing/
[36]: https://enterprise.microsoft.com/en-us/industries/retail-and-consumer-goods/
[37]: https://www.microsoft.com/security/
[38]: https://www.microsoft.com/licensing/
[39]: https://appsource.microsoft.com/
[40]: https://azuremarketplace.microsoft.com/marketplace/
[41]: https://events.microsoft.com/
[42]: https://www.microsoft.com/en-us/sitemap.aspx
[43]: https://www.microsoft.com/en-us/research/
[44]: https://www.microsoft.com/en-us/research/research-area/artificial-intelligence/
[45]: https://www.microsoft.com/en-us/research/research-area/computer-vision/
[46]: https://www.microsoft.com/en-us/research/research-area/graphics-and-multimedia/
[47]: https://www.microsoft.com/en-us/research/research-area/human-computer-interaction/
[48]: https://www.microsoft.com/en-us/research/research-area/human-language-technologies/
[49]: https://www.microsoft.com/en-us/research/research-area/search-information-retrieval/
[50]: https://www.microsoft.com/en-us/research/research-area/data-visualization-analytics-platform/
[51]: https://www.microsoft.com/en-us/research/research-area/hardware-devices-quantum-computing/
[52]: https://www.microsoft.com/en-us/research/research-area/programming-languages-software-engineering/
[53]: https://www.microsoft.com/en-us/research/research-area/security-privacy-cryptography/
[54]: https://www.microsoft.com/en-us/research/research-area/systems-and-networking/
[55]: https://www.microsoft.com/en-us/research/research-area/algorithms/
[56]: https://www.microsoft.com/en-us/research/research-area/computational-sciences-mathematics/
[57]: https://www.microsoft.com/en-us/research/research-area/ecology-environment/
[58]: https://www.microsoft.com/en-us/research/research-area/economics/
[59]: https://www.microsoft.com/en-us/research/research-area/medical-health-genomics/
[60]: https://www.microsoft.com/en-us/research/research-area/social-sciences/
[61]: https://www.microsoft.com/en-us/research/research-area/technology-for-emerging-markets/
[62]: https://www.microsoft.com/en-us/research/products/
[63]: https://www.microsoft.com/en-us/research/academic-programs/
[64]: https://www.microsoft.com/en-us/research/events-conferences/
[65]: https://www.microsoft.com/en-us/research/people/
[66]: https://www.microsoft.com/en-us/research/careers/
[67]: https://www.microsoft.com/en-us/research/blog
[68]: https://www.microsoft.com/en-us/research/blog/category/podcast/
[69]: https://blogs.microsoft.com/next/
[70]: https://www.microsoft.com/en-us/research/lab/microsoft-research-ai/
[71]: http://www.msra.cn
[72]: https://www.microsoft.com/en-us/research/lab/microsoft-research-asia/
[73]: https://www.microsoft.com/en-us/research/lab/microsoft-research-cambridge/
[74]: https://www.microsoft.com/en-us/research/lab/microsoft-research-india/
[75]: https://www.microsoft.com/en-us/research/lab/microsoft-research-montreal/
[76]: https://www.microsoft.com/en-us/research/lab/microsoft-research-new-england/
[77]: https://www.microsoft.com/en-us/research/lab/microsoft-research-new-york/
[78]: https://www.microsoft.com/en-us/research/lab/microsoft-research-redmond/
[79]: https://www.microsoft.com/en-us/research/lab/applied-sciences-group/
[80]: https://www.microsoft.com/en-us/research/group/advanced-technology-lab-cairo-2/
[81]: https://www.microsoft.com/en-us/research/lab/quantum/
[82]: https://www.microsoft.com/en-us/research/about/
[83]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/12/avatar_user__1483137283-180x180.jpg
[84]: mailto:rgal%40microsoft.com
[85]: https://www.microsoft.com/en-us/research/group/graphics/
[86]: https://www.microsoft.com#%21about
[87]: https://www.microsoft.com#%21publications
[88]: https://www.microsoft.com#%21videos
[89]: https://www.microsoft.com#%21cv
[90]: https://www.microsoft.com/en-us/research/wp-content/themes/microsoft-research-theme/images/loading.gif
[91]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/12/RanGal_CV.pdf
[92]: https://twitter.com/MSFTResearch
[93]: https://twitter.com/share
[94]: https://www.microsoft.com/en-us/surface/devices/surface-book-2/overview
[95]: https://www.microsoft.com/en-us/surface/devices/surface-pro/overview
[96]: https://www.xbox.com/en-us/xbox-one-x
[97]: https://www.xbox.com/en-us/xbox-one-s?xr=shellnav
[98]: https://www.microsoft.com/en-us/store/b/virtualreality
[99]: https://www.microsoft.com/en-us/windows/windows-10-apps
[100]: https://store.office.com/en-us/appshome.aspx?
[101]: https://account.microsoft.com/
[102]: https://www.microsoft.com/en-us/download
[103]: https://go.microsoft.com/fwlink/p/?LinkID=824761&clcid=0x409
[104]: https://go.microsoft.com/fwlink/p/?LinkID=824764&clcid=0x409
[105]: https://account.microsoft.com/orders
[106]: https://www.microsoft.com/en-us/store/locations/find-a-store
[107]: https://support.microsoft.com/en-us
[108]: https://www.microsoft.com/en-us/store/b/buy-online-pick-up-in-store?icid=uhf_footer_bopuis
[109]: https://www.microsoft.com/en-us/education/products/office/default.aspx
[110]: https://products.office.com/en-us/academic/compare-office-365-education-plans
[111]: https://www.microsoft.com/en-us/store/b/student
[112]: https://azure.microsoft.com/en-us/community/education/
[113]: https://azure.microsoft.com/
[114]: https://enterprise.microsoft.com/en-us/
[115]: https://www.microsoft.com/en-us/sql-server/
[116]: https://www.microsoft.com/en-us/solution-providers
[117]: https://partner.microsoft.com/en-us/
[118]: https://go.microsoft.com/fwlink/?LinkID=808093
[119]: https://technet.microsoft.com/en-us
[120]: https://mva.microsoft.com/
[121]: https://developer.microsoft.com/en-us/store/register
[122]: https://channel9.msdn.com/
[123]: https://developer.microsoft.com/office
[124]: https://careers.microsoft.com/
[125]: https://www.microsoft.com/en-us/about
[126]: https://news.microsoft.com/
[127]: https://privacy.microsoft.com/en-us
[128]: https://www.microsoft.com/investor/default.aspx
[129]: https://www.microsoft.com/en-us/diversity/
[130]: https://www.microsoft.com/en-us/accessibility/home
[131]: https://www.microsoft.com/en-us/security/default.aspx
[132]: https://www.microsoft.com/en-us/sitemap1.aspx
[133]: https://support.microsoft.com/en-us/contactus
[134]: https://go.microsoft.com/fwlink/?LinkId=521839
[135]: https://go.microsoft.com/fwlink/?LinkID=206977
[136]: https://www.microsoft.com/trademarks
[137]: https://choice.microsoft.com
[138]: https://www.facebook.com/tr?id=435868603227390&ev=PageView&noscript=1

