---
created_at: '2015-12-20T17:02:40.000Z'
title: Windows Kernel Architecture Internals (2010) [pdf]
url: http://research.microsoft.com/en-us/um/redmond/events/wincore2010/Dave_Probert_1.pdf
author: doener
points: 105
story_text: 
comment_text: 
num_comments: 16
story_id: 
story_title: 
story_url: 
parent_id: 
created_at_i: 1450630960
_tags:
- story
- author_doener
- story_10767522
objectID: '10767522'

---
[Source](https://www.microsoft.com/en-us/research/?from=http%3A%2F%2Fresearch.microsoft.com%2Fen-us%2Fum%2Fredmond%2Fevents%2Fwincore2010%2Fdave_probert_1.pdf "Permalink to Microsoft Research – Emerging Technology, Computer, and Software Research")

# Microsoft Research – Emerging Technology, Computer, and Software Research

Try Microsoft Edge A fast and secure browser that's designed for Windows 10 No thanks Get started

This site uses cookies for analytics, personalized content and ads. By continuing to browse this site, you agree to this use. [Learn more][1]

[ ![][2] Microsoft ][3]

Research

* [Microsoft 365][4]
* [Azure][5]
* [Office 365][6]
* [Dynamics 365][7]
* [SQL][8]
* [Windows 10][9]
* More
    * Products & Services
        * [Windows Server][10]
        * [Enterprise Mobility + Security][11]
        * [Power BI][12]
        * [Teams][13]
        * [Visual Studio][14]
        * [Surface for Business][15]
    * Emerging Technologies
        * [AI][16]
        * [Internet of Things][17]
        * [Azure Cognitive Services][18]
        * [Quantum][19]
        * [Research][20]
    * Developer & IT
        * [Docs][21]
        * [TechNet][22]
        * [Developer Network][23]
        * [Windows Dev Center][24]
        * [Windows IT Pro Center][25]
        * [FastTrack][26]
    * Partner
        * [Partner Network][27]
        * [Solution Providers][28]
        * [Partner Center][29]
        * [Cloud Hosting][30]
    * Industries
        * [Education][31]
        * [Financial services][32]
        * [Government][33]
        * [Health][34]
        * [Manufacturing & resources][35]
        * [Retail][36]
    * Other
        * [Security][37]
        * [Licensing][38]
        * [AppSource][39]
        * [Azure Marketplace][40]
        * [Events][41]
    * [View all][42]

[ Research ][43] [Research Home][43]

Research areas

* Intelligence
    * [Artificial Intelligence][44]
    * [Computer vision][45]
    * [Graphics & multimedia][46]
    * [Human-computer interaction][47]
    * [Human language technologies][48]
    * [Search & information retrieval][49]
* Systems
    * [Data visualization, analytics & platform][50]
    * [Hardware, devices & quantum computing][51]
    * [Programming languages & software engineering][52]
    * [Security, privacy & cryptography][53]
    * [Systems & networking][54]
* Theory
    * [Algorithms][55]
    * [Mathematics][56]
* Other Sciences
    * [Ecology & environment][57]
    * [Economics][58]
    * [Medical, health & genomics][59]
    * [Social sciences][60]
    * [Technology for emerging markets][61]

[Products & Downloads][62]

Programs & Events

* [Academic Programs][63]
* [Events & Conferences][64]

[People][65] [Careers][66]

Blogs & Podcasts

* [Microsoft Research Blog][67]
* [The Microsoft Research Podcast][68]
* [The AI Blog][69]

Labs & Locations

* Microsoft Research
    * [MSR AI][70]
    * [Asia Lab (Chinese)][71]
    * [Asia Lab (English)][72]
    * [Cambridge Lab][73]
    * [India Lab][74]
    * [Montreal Lab][75]
    * [New England Lab][76]
    * [New York City Lab][77]
    * [Redmond Lab][78]
* Other labs/locations
    * [Applied Sciences Lab][79]
    * [Advanced Technology Lab Cairo][80]
    * [Quantum][81]
* About
    * [Research at Microsoft][82]

![Machine Learning and the InnerEye for Cancer Treatment][83]

## Machine Learning and the InnerEye for Cancer Treatment

[Listen to the latest episode from Microsoft Research Podcast][84]

![The women who inspire women to pursue careers in STEM][85]

## The women who inspire women to pursue careers in STEM

[How Principal Research Software Engineer, Anne Loomis Thompson, and a team   
of co-founders created a group called Mavens.][86]

![Typing in the Virtual Office Environment][87]

![Typing in the Virtual Office Environment][88]

## Typing in the Virtual Office Environment

[Examining the Effects of Keyboard and Hand Representation in VR ][89]

![New institute explores the <br>future of Cortana][90]

![New institute explores the <br>future of Cortana][91]

## New institute explores the   
future of Cortana

[Today marks the establishment of the Cortana Intelligence Institute – a new, co-funded collaboration, to work on next-generation capabilities for Microsoft's digital assistant Cortana.][92]

###  Search our catalog of thousands of publications, videos, projects, downloads, and more 

Search our catalog

## AI News and Innovations

[ ![AI News and Innovations][93] ][68]

###  [ Microsoft Research Podcast ][68]

Introducing Microsoft Research Podcast, intimate conversations with the researchers behind cutting edge discoveries and how they plan to change the world. Hear directly from Dr. Eric Horvitz, Dr. Jamie Teevan and more every Wednesday. Learn about cutting edge topics like our future relationship with machines, how AI beat Ms. Pac-Man, and the productivity revolution.

[ ![AI News and Innovations][94] ][95]

###  [ Microsoft announces significant expansion of Montreal research lab, new director ][95]

Microsoft plans to significantly expand its Montreal research lab and has hired a renowned artificial intelligence expert, Geoffrey Gordon, to be the lab's new research director.

###  [ Microsoft looks to healthcare partners for ways to bring AI benefits to cancer patients ][96]

###  [ Will machines one day be as creative as humans? Recent methods in artificial intelligence enable AI software to produce rich and creative digital artifacts such as text and images painted from scratch. ][97]

###  [ Neural Fuzzing ][98]

A new method for discovering software security vulnerabilities that uses machine learning and deep neural networks.

[ ![AI News and Innovations][99] ][100]

###  [ Podcast: Life at the Intersection of AI and Society with Dr. Ece Kamar ][100]

As the reality of artificial intelligence continues to capture our imagination, and critical AI systems enter our world at a rapid pace, Dr. Ece Kamar, a senior researcher in the Adaptive Systems and Interaction Group at Microsoft Research, is working to help us understand AI's far-reaching implications, both as we use it, and as we build it.

## Towards quantum computing

[ ![Towards quantum computing][101] ][102]

###  [ New to quantum? Here's a primer. ][102]

An introduction to the mind-bending world of quantum computing. Learn how Microsoft is blending quantum physics with computer science with Quantum Computing 101.

[ ![Towards quantum computing][103] ][104]

###  [ Meet the quantum computing team at Microsoft ][104]

Microsoft has brought together some of the world's top physicists, computer scientists and engineers to build a scalable, fault-tolerant, universal quantum computer.

###  [ Ars Technica: Microsoft makes play for next wave of computing with quantum computing toolkit ][105]

###  [ Stay updated: Empowering the quantum revolution ][19]

###  [ "Quantum computing could solve problems that would take today's computers eons in the time it takes to grab a cup of coffee." ][106]

Read more about Microsoft's quest for a quantum future.

[ ![Towards quantum computing][107] ][108]

###  [ The Future is Quantum with Dr. Krysta Svore ][108]

Podcast: Today, Dr. Svore shares her passion for quantum algorithms and their potential to solve some of the world's biggest problems.

## Security & Privacy

[ ![Security & Privacy][109] ][110]

###  [ Microsoft Security Risk Detection ][110]

A cloud-based tool, formerly known as Project Springfield, that developers can use to look for bugs and other security vulnerabilities in the software they are preparing to release or use, saving companies the heartache of having to patch a bug, deal with crashes or respond to an attack after it has been released.

###  [ Privacy in the Internet (Without Giving up Everything Else) ][111]

###  [ Merging cryptology with AI to safeguard privacy when AI algorithms work on health, education, financial, and other sensitive data. ][112]

###  [ Check out the libraries and tools ][53]

Microsoft security, privacy, and cryptography efforts are guided by the responsibility to build and maintain trust in the computing ecosystem with state-of-the-art systems, controls, and services. 

[ ![Security & Privacy][113] ][114]

###  [ Trusted Cloud Project ][114]

Microsoft Research aims to provide customers of cloud computing complete control over their data—no one should be able to access the data without the customer's permission.

[ ![Security & Privacy][115] ][116]

###  [ Securing the cloud ][116]

At any point in time on any day of the week, Microsoft's cloud computing operations are under attack: The company detects a whopping 1.5 million attempts a day to compromise its systems. But Microsoft isn't just fending off those attacks. It's also learning from them.

## Advances in AI & Machine Learning

[ ![Advances in AI & Machine Learning][117] ][118]

###  [ How do you teach AI to fly? With their own highly realistic simulator ][118]

The ability to differentiate things like trees, curbs, and glass doors come easily to humans, but it's still difficult for AI-based systems. Microsoft researchers are aiming to change that by working on a new set of tools, now available on GitHub, that other researchers and developers can use to train and test robots, drones and other gadgets for operating autonomously and safely in the real world.

[ ![Advances in AI & Machine Learning][119] ][120]

###  [ Leading innovation in AI to improve citizen health ][120]

How can doctors keep up with the explosion of medical research? The Azure for Research program provided an Azure grant to University College London to quickly develop and deploy AI solutions in the cloud. 

###  [ Generating computer code based on a user's intent with deep learning ][121]

###  [ How Microsoft researchers are helping keep AI accurate and unbiased ][122]

###  [ We're hiring in AI! ][66]

Researchers in AI are pursuing computing advances to create intelligent machines that complement human reasoning to augment and enrich our experience and competencies. 

[ ![Advances in AI & Machine Learning][123] ][124]

###  [ Minecraft and AI: Enabling technology that can collaborate with humans ][124]

Learn more about Project Malmo, a platform that uses the world of Minecraft as a testing ground for advanced artificial intelligence research and innovation.

### 

## Scientists and engineers working together to help solve global challenges

### In the news

#### [Microsoft’s Cortana Intelligence Institute cofounder on building better AI][125]

Windows Central | February 16, 2018

#### ["We're in a diversity crisis": cofounder of Black in AI on what's poisoning algorithms in our lives][126]

MIT Technology Review | February 14, 2018

#### [How DNA could store all the world's data in a semi-trailer][127]

Financial Times | February 4, 2018

### Get involved

#### Academic and external collaboration

We collaborate with the world's top researchers to develop technologies that help solve global challenges.    
[Explore academic programs][63]

#### Full-time jobs and internships

Work with world-renowned colleagues on meaningful research and product incubations in labs around the world.    
[Explore more research careers][66]

### Award-winning researchers

Microsoft researchers have received a myriad of prestigious national and international honors, including the ACM A.M. Turing Award, considered the highest distinction in computer science.

[**Meet our award-winning researchers >**][128]  
[**See our full researcher index >**][65]

##  Follow Microsoft Research 

* * [Follow @MSFTResearch][129]
* ##  Share this page 
* * [Tweet][130]
* #### What's new
* [Surface Book 2][131]
* [Surface Pro][132]
* [Xbox One X][133]
* [Xbox One S][134]
* [VR & mixed reality][135]
* [Windows 10 apps][136]
* [Office apps][137]

#### Store & Support

* [Account profile][138]
* [Download Center][139]
* [Sales & support][140]
* [Returns][141]
* [Order tracking][142]
* [Store locations][143]
* [Support][144]
* [Buy online, pick up in store][145]

#### Education

* [Microsoft in education][31]
* [Office for students][146]
* [Office 365 for schools][147]
* [Deals for students & educators ][148]
* [Microsoft Azure in education][149]

#### Enterprise

* [Microsoft Azure ][150]
* [Enterprise][151]
* [Data platform][152]
* [Find a solutions provider][153]
* [Microsoft partner resources ][154]
* [Microsoft AppSource ][155]
* [Manufacturing & resources][35]
* [Financial services][32]

#### Developer

* [Microsoft Visual Studio][14]
* [Windows Dev Center][24]
* [Developer Network][23]
* [TechNet][156]
* [Microsoft Virtual Academy][157]
* [Microsoft developer program][158]
* [Channel 9][159]
* [Office Dev Center][160]

#### Company

* [Careers][161]
* [About Microsoft][162]
* [Company news][163]
* [Privacy at Microsoft][164]
* [Investors][165]
* [Diversity and inclusion][166]
* [Accessibility][167]
* [Security][168]
* [Sitemap][169]
* [Contact us][170]
* [Privacy & cookies ][171]
* [Terms of use][172]
* [Trademarks][173]
* [About our ads][174]
* © Microsoft 2018

![][175]

[1]: https://go.microsoft.com/fwlink/?linkid=845480
[2]: https://img-prod-cms-rt-microsoft-com.akamaized.net/cms/api/am/imageFileData/RE1Mu3b?ver=5c31
[3]: https://www.microsoft.com
[4]: https://www.microsoft.com/en-us/microsoft-365
[5]: https://azure.microsoft.com
[6]: https://products.office.com/en-us/business/office
[7]: https://dynamics.microsoft.com/en-us/
[8]: https://www.microsoft.com/sql-server/
[9]: https://www.microsoft.com/en-us/windowsforbusiness
[10]: https://www.microsoft.com/cloud-platform/windows-server
[11]: https://www.microsoft.com/cloud-platform/enterprise-mobility-security
[12]: https://powerbi.microsoft.com/en-us/
[13]: https://products.office.com/en-us/microsoft-teams/group-chat-software
[14]: https://www.visualstudio.com/
[15]: https://www.microsoft.com/en-us/surface/business/overview
[16]: https://www.microsoft.com/ai/
[17]: https://www.microsoft.com/internet-of-things
[18]: https://azure.microsoft.com/services/cognitive-services/
[19]: https://www.microsoft.com/quantum/
[20]: https://www.microsoft.com/research/
[21]: https://docs.microsoft.com/en-us/
[22]: https://technet.microsoft.com/en-us/ms376608.aspx
[23]: https://msdn.microsoft.com/en-us
[24]: https://developer.microsoft.com/en-us/windows
[25]: https://www.microsoft.com/en-us/itpro/windows
[26]: https://fasttrack.microsoft.com/office
[27]: https://partner.microsoft.com/
[28]: https://www.microsoft.com/solution-providers/
[29]: https://partnercenter.microsoft.com/partner/home
[30]: https://www.microsoft.com/en-us/cloudandhosting
[31]: https://www.microsoft.com/en-us/education
[32]: https://enterprise.microsoft.com/en-us
[33]: https://enterprise.microsoft.com/en-us/industries/government/
[34]: https://enterprise.microsoft.com/en-us/industries/health/
[35]: https://enterprise.microsoft.com/en-us/industries/discrete-manufacturing/
[36]: https://enterprise.microsoft.com/en-us/industries/retail-and-consumer-goods/
[37]: https://www.microsoft.com/security/
[38]: https://www.microsoft.com/licensing/
[39]: https://appsource.microsoft.com/
[40]: https://azuremarketplace.microsoft.com/marketplace/
[41]: https://events.microsoft.com/
[42]: https://www.microsoft.com/en-us/sitemap.aspx
[43]: https://www.microsoft.com/en-us/research/
[44]: https://www.microsoft.com/en-us/research/research-area/artificial-intelligence/
[45]: https://www.microsoft.com/en-us/research/research-area/computer-vision/
[46]: https://www.microsoft.com/en-us/research/research-area/graphics-and-multimedia/
[47]: https://www.microsoft.com/en-us/research/research-area/human-computer-interaction/
[48]: https://www.microsoft.com/en-us/research/research-area/human-language-technologies/
[49]: https://www.microsoft.com/en-us/research/research-area/search-information-retrieval/
[50]: https://www.microsoft.com/en-us/research/research-area/data-visualization-analytics-platform/
[51]: https://www.microsoft.com/en-us/research/research-area/hardware-devices-quantum-computing/
[52]: https://www.microsoft.com/en-us/research/research-area/programming-languages-software-engineering/
[53]: https://www.microsoft.com/en-us/research/research-area/security-privacy-cryptography/
[54]: https://www.microsoft.com/en-us/research/research-area/systems-and-networking/
[55]: https://www.microsoft.com/en-us/research/research-area/algorithms/
[56]: https://www.microsoft.com/en-us/research/research-area/computational-sciences-mathematics/
[57]: https://www.microsoft.com/en-us/research/research-area/ecology-environment/
[58]: https://www.microsoft.com/en-us/research/research-area/economics/
[59]: https://www.microsoft.com/en-us/research/research-area/medical-health-genomics/
[60]: https://www.microsoft.com/en-us/research/research-area/social-sciences/
[61]: https://www.microsoft.com/en-us/research/research-area/technology-for-emerging-markets/
[62]: https://www.microsoft.com/en-us/research/products/
[63]: https://www.microsoft.com/en-us/research/academic-programs/
[64]: https://www.microsoft.com/en-us/research/events-conferences/
[65]: https://www.microsoft.com/en-us/research/people/
[66]: https://www.microsoft.com/en-us/research/careers/
[67]: https://www.microsoft.com/en-us/research/blog
[68]: https://www.microsoft.com/en-us/research/blog/category/podcast/
[69]: https://blogs.microsoft.com/next/
[70]: https://www.microsoft.com/en-us/research/lab/microsoft-research-ai/
[71]: http://www.msra.cn
[72]: https://www.microsoft.com/en-us/research/lab/microsoft-research-asia/
[73]: https://www.microsoft.com/en-us/research/lab/microsoft-research-cambridge/
[74]: https://www.microsoft.com/en-us/research/lab/microsoft-research-india/
[75]: https://www.microsoft.com/en-us/research/lab/microsoft-research-montreal/
[76]: https://www.microsoft.com/en-us/research/lab/microsoft-research-new-england/
[77]: https://www.microsoft.com/en-us/research/lab/microsoft-research-new-york/
[78]: https://www.microsoft.com/en-us/research/lab/microsoft-research-redmond/
[79]: https://www.microsoft.com/en-us/research/lab/applied-sciences-group/
[80]: https://www.microsoft.com/en-us/research/group/advanced-technology-lab-cairo-2/
[81]: https://www.microsoft.com/en-us/research/lab/quantum/
[82]: https://www.microsoft.com/en-us/research/about/
[83]: https://www.microsoft.com/en-us/research/uploads/prod/2018/02/MicrosoftResearch_Podcast_Antonio-Criminisi_MCR-Homepage-Hero_1600x600-800x550.jpg
[84]: https://www.microsoft.com/en-us/research/blog/machine-learning-and-the-innereye-for-cancer-treatment-with-dr-antonio-criminisi/?OCID=msr_podcast_acriminisi_hero
[85]: https://www.microsoft.com/en-us/research/uploads/prod/2018/02/I_Chose_Stem_Hero-1600-x-600-800x550.jpg
[86]: https://www.microsoft.com/en-us/research/blog/the-women-who-inspire-women-to-pursue-careers-in-stem/?OCID=msr_blog_icstem_hero
[87]: https://www.microsoft.com/en-us/research/uploads/prod/2018/02/Michel_VRType-1040x585-800x550.jpg
[88]: https://www.microsoft.com/en-us/research/uploads/prod/2018/02/Michel_VRType-1040x585.jpg
[89]: https://www.microsoft.com/en-us/research/blog/typing-in-the-virtual-office-environment-examining-the-effects-of-keyboard-and-hand-representation-in-vr/?OCID=msr_blog_vroffice_hero
[90]: https://www.microsoft.com/en-us/research/uploads/prod/2018/01/Cortana-1000x550-800x550.jpg
[91]: https://www.microsoft.com/en-us/research/uploads/prod/2018/01/Cortana-1000x550.jpg
[92]: https://www.microsoft.com/en-us/research/blog/new-institute-explores-future-cortana/?OCID=msr_blog_cortanarmit_hero
[93]: https://www.microsoft.com/en-us/research/wp-content/uploads/2017/12/MS_ResearchPodcast_Logo_800x550_Carousel.jpg
[94]: https://www.microsoft.com/en-us/research/uploads/prod/2018/01/Geoff_800x550.jpg
[95]: http://blogs.microsoft.com/ai/montreal-ai-research-expansion/?wt.mc_id=p5qjnp-job-mcr-hp%20
[96]: https://blogs.microsoft.com/ai/2017/11/28/project-innereye-cancer-treatment/
[97]: https://www.microsoft.com/en-us/research/blog/will-machines-one-day-creative-humans/
[98]: https://www.microsoft.com/en-us/research/blog/neural-fuzzing/
[99]: https://www.microsoft.com/en-us/research/uploads/prod/2018/02/MicrosoftResearch_Podcast_Ece_Carousel_480x280.jpg
[100]: https://www.microsoft.com/en-us/research/blog/life-at-intersection-of-ai-society-ece-kamar/?OCID=msr_podcast_ekamar_hpcar
[101]: https://www.microsoft.com/en-us/research/wp-content/uploads/2017/09/canvas-2.png
[102]: https://aka.ms/Jw6ek3
[103]: https://www.microsoft.com/en-us/research/wp-content/uploads/2016/08/MS-Stories-Station-Q-Freedman-Michael-12-1-800x550.jpg
[104]: https://www.microsoft.com/en-us/quantum/default.aspx
[105]: https://arstechnica.com/gadgets/2017/09/microsoft-quantum-toolkit/
[106]: http://news.microsoft.com/stories/stationq/index.html
[107]: https://www.microsoft.com/en-us/research/uploads/prod/2018/01/MicrosoftResearch_Podcast_Krysta_HomepageCarousel_800x550.jpg
[108]: https://www.microsoft.com/en-us/research/blog/future-is-quantum-with-dr-krysta-svore/?OCID=msr_podcast_ksvore_hpcar
[109]: https://www.microsoft.com/en-us/research/wp-content/uploads/2017/07/AI_for_Security_850x550.jpg
[110]: https://blogs.microsoft.com/next/2017/07/21/ai-for-security-microsoft-security-risk-detection-makes-debut/
[111]: https://www.microsoft.com/en-us/research/video/privacy-internet-without-giving-everything-else/
[112]: https://www.microsoft.com/en-us/research/video/research-focus-private-ai/#
[113]: https://www.microsoft.com/en-us/research/wp-content/uploads/2017/07/Trusted_Cloud_Project_3_800x550.jpg
[114]: https://www.microsoft.com/en-us/research/project/trusted-cloud/
[115]: https://www.microsoft.com/en-us/research/wp-content/uploads/2017/07/Securing_the_Cloud_2_800x550.jpg
[116]: https://news.microsoft.com/stories/cloud-security/
[117]: https://www.microsoft.com/en-us/research/wp-content/uploads/2017/05/Collection1_AIRP_1920x1320-800x550.jpg
[118]: https://blogs.microsoft.com/next/2017/02/15/microsoft-shares-open-source-system-training-drones-gadgets-move-safely
[119]: https://www.microsoft.com/en-us/research/wp-content/uploads/2017/05/Collection2_AIHealth_1920x1320-800x550.jpg
[120]: https://www.microsoft.com/en-us/research/blog/democratizing-ai-improve-citizen-health/
[121]: https://www.microsoft.com/en-us/research/blog/deep-learning-program-synthesis/
[122]: https://www.microsoft.com/en-us/research/blog/ai-getting-smarter-microsoft-researchers-ensure-ai-accuracy/
[123]: https://www.microsoft.com/en-us/research/wp-content/uploads/2017/05/Collection3_Malmo_1920x1320-800x550.jpg
[124]: https://www.microsoft.com/en-us/research/video/project-malmo-enabling-ai-technology-can-collaborate-humans/
[125]: https://www.windowscentral.com/cortana-intelligence-institute-co-founder-ryen-white-talks-cortana
[126]: https://www.technologyreview.com/s/610192/were-in-a-diversity-crisis-black-in-ais-founder-on-whats-poisoning-the-algorithms-in-our/
[127]: https://www.ft.com/content/45ea22b0-cec2-11e7-947e-f1ea5435bcc7
[128]: https://www.microsoft.com/en-us/research/awards/
[129]: https://twitter.com/MSFTResearch
[130]: https://twitter.com/share
[131]: https://www.microsoft.com/en-us/surface/devices/surface-book-2/overview
[132]: https://www.microsoft.com/en-us/surface/devices/surface-pro/overview
[133]: https://www.xbox.com/en-us/xbox-one-x
[134]: https://www.xbox.com/en-us/xbox-one-s?xr=shellnav
[135]: https://www.microsoft.com/en-us/store/b/virtualreality
[136]: https://www.microsoft.com/en-us/windows/windows-10-apps
[137]: https://store.office.com/en-us/appshome.aspx?
[138]: https://account.microsoft.com/
[139]: https://www.microsoft.com/en-us/download
[140]: https://go.microsoft.com/fwlink/p/?LinkID=824761&clcid=0x409
[141]: https://go.microsoft.com/fwlink/p/?LinkID=824764&clcid=0x409
[142]: https://account.microsoft.com/orders
[143]: https://www.microsoft.com/en-us/store/locations/find-a-store
[144]: https://support.microsoft.com/en-us
[145]: https://www.microsoft.com/en-us/store/b/buy-online-pick-up-in-store?icid=uhf_footer_bopuis
[146]: https://www.microsoft.com/en-us/education/products/office/default.aspx
[147]: https://products.office.com/en-us/academic/compare-office-365-education-plans
[148]: https://www.microsoft.com/en-us/store/b/student
[149]: https://azure.microsoft.com/en-us/community/education/
[150]: https://azure.microsoft.com/
[151]: https://enterprise.microsoft.com/en-us/
[152]: https://www.microsoft.com/en-us/sql-server/
[153]: https://www.microsoft.com/en-us/solution-providers
[154]: https://partner.microsoft.com/en-us/
[155]: https://go.microsoft.com/fwlink/?LinkID=808093
[156]: https://technet.microsoft.com/en-us
[157]: https://mva.microsoft.com/
[158]: https://developer.microsoft.com/en-us/store/register
[159]: https://channel9.msdn.com/
[160]: https://developer.microsoft.com/office
[161]: https://careers.microsoft.com/
[162]: https://www.microsoft.com/en-us/about
[163]: https://news.microsoft.com/
[164]: https://privacy.microsoft.com/en-us
[165]: https://www.microsoft.com/investor/default.aspx
[166]: https://www.microsoft.com/en-us/diversity/
[167]: https://www.microsoft.com/en-us/accessibility/home
[168]: https://www.microsoft.com/en-us/security/default.aspx
[169]: https://www.microsoft.com/en-us/sitemap1.aspx
[170]: https://support.microsoft.com/en-us/contactus
[171]: https://go.microsoft.com/fwlink/?LinkId=521839
[172]: https://go.microsoft.com/fwlink/?LinkID=206977
[173]: https://www.microsoft.com/trademarks
[174]: https://choice.microsoft.com
[175]: https://www.facebook.com/tr?id=435868603227390&ev=PageView&noscript=1

